Option Explicit

Dim Fso, ShellApp, WshShell
Dim fileXml, objXML
Dim node, item
Dim source, target
Dim ffrom, fto
Dim approved, success

Set Fso = CreateObject("Scripting.FileSystemObject")
Set ShellApp = CreateObject("Shell.Application")
Set WshShell = CreateObject("WScript.shell")
Set objXML = WScript.CreateObject("MSXML.DOMDocument")

If WScript.Arguments.Count=2 Then
	source = WScript.Arguments(0)
	target = WScript.Arguments(1)
End If

If source <> "" Then
	ffrom = source
Else
	ffrom = Fso.GetFolder(".")
End If
If target <> "" Then
	fto = target
Else
	fto = Fso.BuildPath(WshShell.SpecialFolders("Appdata"), "Yamaha\YS3\data_folder\template_folder\xml_data")
End If

If Fso.FolderExists(fto) Then
	fileXml = replace(Fso.BuildPath(ffrom, WScript.ScriptName),"install.vbs", "dcs.xml")
	objXML.load(fileXML)

	approved = False
	success = False

	For Each node In objXML.getElementsByTagName("install")
		For Each item In node.childNodes
			Select Case item.nodeName
				Case "info"
					approved = ShowPreMessage(item)
				Case "data"
					If approved = True Then
						success = InvokeCopyData(item, ffrom, fto)
					End If
			End Select
		Next
	Next

	Set Fso = Nothing

	If success = True Then
		MsgBox "Installation completed. Please restart Y-S3 to use the added speakers.", vbOKOnly, "Y-S3 Data Installer"
	End If
Else
	MsgBox "Y-S3 is not installed.", vbOKOnly, "Y-S3 Data Installer"
End If

Function ShowPreMessage(item)
	Dim oked, index, leaf
	Dim mname, answer
	oked = False
	index = 0
	For Each leaf In item.childNodes
		Select Case leaf.nodeName
			Case "model"
				If mname = "" Then
					mname = "The following speaker data will be installed to Y-S3 data folder." + vbNewLine + vbNewLine + vbTab + "Models :" + vbTab + leaf.firstChild.nodeValue
				Else
					mname = mname + vbNewLine + vbTab + vbTab + leaf.firstChild.nodeValue
				End If
		End Select
		index = index + 1 
	Next
	answer = MsgBox (mname, vbOKCancel, "Y-S3 Data Installer")
	If answer = vbOK Then
		oked = True
	End If
	ShowPreMessage = oked
End Function

Function InvokeCopyData(item, filefrom, fileto)
	Dim elmt, leaf
	Dim fname, check
	Dim latest
	latest = False
	latest = GetRevision(fileto) <= GetRevision(filefrom)
	For Each elmt In item.childNodes
		check = "false"
		For Each leaf In elmt.childNodes
			Select Case leaf.nodeName
				Case "from"
					fname = leaf.firstChild.nodeValue
				Case "check"
					check = leaf.firstChild.nodeValue
			End Select
		Next
		If elmt.nodeName <> "" Then
			Select Case elmt.nodeName
				Case "file"
					If (check = "false") Or ((check = "true") And (latest = True)) Then
						Fso.CopyFile Fso.BuildPath(filefrom, fname), Fso.BuildPath(fileto, fname), True
					End If
				Case "folder"
					If (check = "true") And (latest = True) Then
						Fso.DeleteFile Fso.BuildPath(Fso.BuildPath(fileto, fname), "*.xml"), True
						Fso.CopyFolder Fso.BuildPath(filefrom, fname), Fso.BuildPath(fileto, fname), True
					ElseIf check = "false" Then
						Fso.CopyFolder Fso.BuildPath(filefrom, fname), Fso.BuildPath(fileto, fname), True
					End If
			End Select
		End If
	Next
	InvokeCopyData = True
End Function

Function GetRevision(dir)
	dim fullpath, stream, result
	result = 0
	fullpath = Fso.BuildPath(dir, "package.info")
	If Fso.FileExists(fullpath) Then
		Set stream = Fso.OpenTextFile(fullpath, 1)
		Do Until stream.AtEndOfLine = True
			result = CInt(stream.ReadLine)
			Exit Do
		Loop
		stream.Close
		Set stream = Nothing
	End If
	GetRevision = result
End Function

